﻿using System;
using System.Runtime.InteropServices;

namespace POC
{
    [ComVisible(true)]
    class ClassFactory<T> : IClassFactory where T : IMarshal, new()
    {
        static void QueryInterface(object obj, ref Guid riid, out IntPtr ppvObject)
        {
            IntPtr unk = Marshal.GetIUnknownForObject(obj);
            Console.WriteLine(riid);
            int result = Marshal.QueryInterface(unk, ref riid, out ppvObject);
            if (result != 0)
            {
                Marshal.ThrowExceptionForHR(result);
            }
        }

        void IClassFactory.CreateInstance(IntPtr pUnkOuter, ref Guid riid, out IntPtr ppvObject)
        {
            Console.WriteLine("Create Instance");
            QueryInterface(new T(), ref riid, out ppvObject);
        }

        void IClassFactory.LockServer(bool fLock)
        {
        }
    }
}
