﻿using System;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace POC
{
    [Guid("00000003-0000-0000-C000-000000000046"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), ComImport]
    interface IMarshal
    {
        Guid GetUnmarshalClass(
            ref Guid riid,
            IntPtr pv,
            int dwDestContext,
            IntPtr pvDestContext,
            int mshlflags);

        int GetMarshalSizeMax(ref Guid riid,
            IntPtr pv,
            int dwDestContext,
            IntPtr pvDestContext,
            int mshlflags);

        void MarshalInterface(IStream pStm,
                ref Guid riid,
                IntPtr pv,
                int dwDestContext,
                IntPtr pvDestContext,
                int mshlflags);

        [PreserveSig]
        int UnmarshalInterface(IStream pStm, ref Guid riid, out IntPtr ppv);
        void ReleaseMarshalData(IStream pStm);
        void DisconnectObject(int dwReserved);
    }


    [ComImport, Guid("00000001-0000-0000-C000-000000000046"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    public interface IClassFactory
    {
        void CreateInstance(IntPtr pUnkOuter,
            ref Guid riid, out IntPtr ppvObject);
        void LockServer(bool fLock);
    }

    enum GLOBALOPT_UNMARSHALING_POLICY_VALUES
    {
        COMGLB_UNMARSHALING_POLICY_NORMAL = 0,
        COMGLB_UNMARSHALING_POLICY_STRONG = 1,
        COMGLB_UNMARSHALING_POLICY_HYBRID = 2
    }

    enum GLOBALOPT_PROPERTIES
    {
        COMGLB_EXCEPTION_HANDLING = 1,  //defines COM exception handling behavior
        COMGLB_APPID = 2,   //sets the AppID for the process
        COMGLB_RPC_THREADPOOL_SETTING = 3,   // sets the ThreadPool behavior of RPC runtime in the process.
        COMGLB_RO_SETTINGS = 4,   // miscellaneous settings.
        COMGLB_UNMARSHALING_POLICY = 5,  // policy applied to CoUnmarshalInterface
    }

    [Guid("0000015B-0000-0000-C000-000000000046")]
    [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    [ComImport]
    interface IGlobalOptions
    {
        void Set(GLOBALOPT_PROPERTIES dwProperty,
                 IntPtr dwValue);
        IntPtr Query(GLOBALOPT_PROPERTIES dwProperty);
    }

    [Guid("0000034B-0000-0000-C000-000000000046")]
    [ComImport]
    class GlobalOptions
    {
    }

    [Guid("53f926d2-083c-4283-b45b-81c007237e44")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IStorageItem2 {
        IAsyncOperation_StorageFolder GetParentAsync();
    }

    enum CreationCollisionOption
    {
        GenerateUniqueName = 0,
        ReplaceExisting = 1,
        FailIfExists = 2,
        OpenIfExists = 3
    };

    [Guid("72d1cb78-b3ef-4f75-a80b-6fd9dae2944b")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IStorageFolder
    {
        IAsyncOperation_StorageFile CreateFileAsync([MarshalAs(UnmanagedType.HString)] string name);
        IAsyncOperation_StorageFile CreateFileAsync([MarshalAs(UnmanagedType.HString)] string name, CreationCollisionOption options);
        void Proc8();
        void Proc9();

        //HRESULT Proc7(/* Stack Offset: 8 */ [In] HSTRING p0, /* Stack Offset: 16 */ [In] /* ENUM32 */ int p1, /* Stack Offset: 24 */ [Out] IAsyncOperation<Windows::Storage::StorageFile>** p2);
        //HRESULT Proc8(/* Stack Offset: 8 */ [In] HSTRING p0, /* Stack Offset: 16 */ [Out] IAsyncOperation<Windows::Storage::StorageFolder>** p1);
        //HRESULT Proc9(/* Stack Offset: 8 */ [In] HSTRING p0, /* Stack Offset: 16 */ [In] /* ENUM32 */ int p1, /* Stack Offset: 24 */ [Out] IAsyncOperation<Windows::Storage::StorageFolder>** p2);
        IAsyncOperation_StorageFile GetFileAsync([MarshalAs(UnmanagedType.HString)] string name);
        IAsyncOperation_StorageFolder GetFolderAsync([MarshalAs(UnmanagedType.HString)] string name);
        //HRESULT Proc12(/* Stack Offset: 8 */ [In] HSTRING p0, /* Stack Offset: 16 */ [Out] IAsyncOperation<Windows::Storage::IStorageItem>** p1);
        //HRESULT Proc13(/* Stack Offset: 8 */ [Out] IAsyncOperation<IVectorView<Windows::Storage::StorageFile>>** p0);
        //HRESULT Proc14(/* Stack Offset: 8 */ [Out] IAsyncOperation<IVectorView<Windows::Storage::StorageFolder>>** p0);
        //HRESULT Proc15(/* Stack Offset: 8 */ [Out] IAsyncOperation<IVectorView<Windows::Storage::IStorageItem>>** p0);
    }

    enum FileAccessMode
    {
        Read = 0,
        ReadWrite = 1
    }

    enum NameCollisionOption
    {
        GenerateUniqueName = 0,
        ReplaceExisting = 1,
        FailIfExists = 2
    }

    [Guid("fa3f6186-4214-428c-a64c-14c9ac7315ea")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IStorageFile {
        [return: MarshalAs(UnmanagedType.HString)]
        string get_FileType();
        [return: MarshalAs(UnmanagedType.HString)]
        string get_ContentType();
        void OpenAsync();
        void OpenTransactedWriteAsync();
        IAsyncOperation_StorageFile CopyAsync(IStorageFolder destinationFolder);
        IAsyncOperation_StorageFile CopyAsync(IStorageFolder destinationFolder, [MarshalAs(UnmanagedType.HString)] string desiredNewName);
        IAsyncOperation_StorageFile CopyAsync(IStorageFolder destinationFolder, [MarshalAs(UnmanagedType.HString)] string desiredNewName, NameCollisionOption option);
        IAsyncAction CopyAndReplaceAsync(IStorageFile fileToReplace);
        IAsyncAction MoveAsync(IStorageFolder destinationFolder);
        IAsyncAction MoveAsync(IStorageFolder destinationFolder, [MarshalAs(UnmanagedType.HString)] string desiredNewName);
        IAsyncAction MoveAsync(IStorageFolder destinationFolder, [MarshalAs(UnmanagedType.HString)] string desiredNewName, NameCollisionOption option);
        IAsyncAction MoveAndReplaceAsync(IStorageFile fileToReplace);
    }

    [Guid("4207a996-ca2f-42f7-bde8-8b10457a7f30")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IStorageItem {
        IAsyncAction RenameAsync([MarshalAs(UnmanagedType.HString)] string p0);
        void Proc7();
        void Proc8();
        void Proc9();
        void Proc10();
        
        //HRESULT Proc7(/* Stack Offset: 8 */ [In] HSTRING p0, /* Stack Offset: 16 */ [In] /* ENUM32 */ int p1, /* Stack Offset: 24 */ [Out] IAsyncAction** p2);
        //HRESULT Proc8(/* Stack Offset: 8 */ [Out] IAsyncAction** p0);
        //HRESULT Proc9(/* Stack Offset: 8 */ [In] /* ENUM32 */ int p0, /* Stack Offset: 16 */ [Out] IAsyncAction** p1);
        //HRESULT Proc10(/* Stack Offset: 8 */ [Out] IAsyncOperation<Windows::Storage::FileProperties::BasicProperties>** p0);
        [return: MarshalAs(UnmanagedType.HString)]
        string get_Name();
        [return: MarshalAs(UnmanagedType.HString)]
        string get_Path();
        //HRESULT Proc13(/* Stack Offset: 8 */ [Out] /* ENUM32 */ int* p0);
        //HRESULT Proc14(/* Stack Offset: 8 */ [Out] struct Struct_1* p0);
        //HRESULT Proc15(/* Stack Offset: 8 */ [In] /* ENUM32 */ int p0, /* Stack Offset: 16 */ [Out] sbyte* p1);
    }

    enum AsyncStatus
    {
        Started = 0,
        Completed,
        Canceled,
        Error,
    }

    [Guid("00000036-0000-0000-c000-000000000046")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IAsyncInfo
    {
        int get_Id();
        AsyncStatus get_Status();
        int get_Error();
        void Cancel();
        void Close();
    }

    [Guid("6be9e7d7-e83a-5cbc-802c-1768960b52c3")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IAsyncOperation_StorageFolder
    {
        void put_Completed(IntPtr p0);
        IntPtr get_Completed();
        IStorageFolder GetResults();
    }

    
    [Guid("5e52f8ce-aced-5a42-95b4-f674dd84885e")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IAsyncOperation_StorageFile
    {
        void put_Completed(IntPtr p0);
        IntPtr get_Completed();
        IStorageFile GetResults();
    }

    [Guid("08f327ff-85d5-48b9-aee9-28511e339f9f")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IStorageFolderStatics {
        IAsyncOperation_StorageFolder GetFolderFromPathAsync([MarshalAs(UnmanagedType.HString)] string p0);
    }

    [Guid("5A648006-843A-4DA9-865B-9D26E5DFAD7B")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IAsyncAction
    {
        void put_Completed();
        void get_Completed();
        void GetResults();
    }

    [Guid("905A0FE2-BC53-11DF-8C49-001E4FC686DA")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IInputStream
    {
        //HRESULT ReadAsync([in] Windows.Storage.Streams.IBuffer* buffer, [in] UINT32 count, [in] Windows.Storage.Streams.InputStreamOptions options, [out] [retval] Windows.Foundation.IAsyncOperationWithProgress<Windows.Storage.Streams.IBuffer*, UINT32>** operation);
    }

    [Guid("905A0FE6-BC53-11DF-8C49-001E4FC686DA")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IOutputStream
    {
        //HRESULT WriteAsync([in] Windows.Storage.Streams.IBuffer* buffer, [out] [retval] Windows.Foundation.IAsyncOperationWithProgress<UINT32, UINT32>** operation);
        //sbyte FlushAsync();
    }
               
    [Guid("905A0FE1-BC53-11DF-8C49-001E4FC686DA")]
    [InterfaceType(ComInterfaceType.InterfaceIsIInspectable)]
    interface IRandomAccessStream
    {
        ulong get_Size();
        void set_Size(ulong size);
        IInputStream GetInputStreamAt(ulong position);
        IOutputStream GetOutputStreamAt(ulong position);
        ulong get_Position();
        void Seek(ulong position);
        IRandomAccessStream CloneStream();
        sbyte CanRead();
        sbyte CanWrite();
    }
}
