﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace POC
{
    [ComVisible(true), ComDefaultInterface(typeof(IMarshal))]
    class Marshaled : IMarshal
    {
        public Marshaled()
        {
        }

        void IMarshal.DisconnectObject(int dwReserved)
        {
        }

        void IMarshal.ReleaseMarshalData(IStream pStm)
        {
        }

        [DllImport("ole32.dll", PreserveSig = false)]
        public static extern int CoUnmarshalInterface(IStream stm, ref Guid riid, out IntPtr ppv);

        int IMarshal.UnmarshalInterface(IStream pStm, ref Guid riid, out IntPtr ppv)
        {
            Console.WriteLine("UnmarshalInterface");
            int hr = CoUnmarshalInterface(pStm, ref riid, out ppv);
            if (hr != 0)
                return hr;
            Obj = Marshal.GetObjectForIUnknown(ppv);

            StreamWrapper wrapper = new StreamWrapper(pStm);
            BinaryReader reader = new BinaryReader(wrapper);
            int length = reader.ReadInt32();
            if (length > 0)
            {
                Console.WriteLine("Extra Length: {0}", length);
                MemoryStream stm = new MemoryStream(reader.ReadAll(length));
                reader = new BinaryReader(stm);
                if (reader.ReadInt32() != 0)
                {
                    IStreamImpl istm = new IStreamImpl(stm);
                    hr = CoUnmarshalInterface(istm, ref riid, out ppv);
                    if (hr != 0)
                        return hr;
                    Obj2 = Marshal.GetObjectForIUnknown(ppv);
                }

                if (reader.ReadInt32() != 0)
                {
                    ExtraData = reader.ReadAll(reader.ReadInt32());
                }
            }

            return hr;
        }

        public static object Obj { get; private set; }
        public static object Obj2 { get; private set; }
        public byte[] ExtraData { get; private set; }

        Guid IMarshal.GetUnmarshalClass(ref Guid riid, IntPtr pv, int dwDestContext, IntPtr pvDestContext, int mshlflags)
        {
            throw new NotImplementedException();
        }

        int IMarshal.GetMarshalSizeMax(ref Guid riid, IntPtr pv, int dwDestContext, IntPtr pvDestContext, int mshlflags)
        {
            throw new NotImplementedException();
        }

        void IMarshal.MarshalInterface(IStream pStm, ref Guid riid, IntPtr pv, int dwDestContext, IntPtr pvDestContext, int mshlflags)
        {
            throw new NotImplementedException();
        }
    }
}
